Subject: Re: [PATCH v3 3/3] asm-generic/io.h: Silence -Wnull-pointer-arithmetic warning on PCI_IOBASE

From: kernel test robot <[email-masked]>
Date: Thu, 22 Apr 2021 00:59:57 +0800

Hi Niklas,

I love your patch! Yet something to improve:

[auto build test ERROR on soc/for-next]
[also build test ERROR on asm-generic/master v5.12-rc8 next-20210421]
[cannot apply to arc/for-next]
[If your patch is applied to the wrong git tree, kindly drop us a note.
And when submitting patch, we suggest to use '--base' as documented in
https://git-scm.com/docs/git-format-patch]

url:    https://github.com/0day-ci/linux/commits/Niklas-Schnelle/asm-generic-io-h-Silence-Wnull-pointer-arithmetic-warning-on-PCI_IOBASE/20210421-192025
base:   https://git.kernel.org/pub/scm/linux/kernel/git/soc/soc.git for-next
config: h8300-randconfig-r025-20210421 (attached as .config)
compiler: h8300-linux-gcc (GCC) 9.3.0
reproduce (this is a W=1 build):
        wget https://raw.githubusercontent.com/intel/lkp-tests/master/sbin/make.cross -O ~/bin/make.cross
        chmod +x ~/bin/make.cross
        # https://github.com/0day-ci/linux/commit/05bc9b9b640336015712d139ebc42830d12a82da
        git remote add linux-review https://github.com/0day-ci/linux
        git fetch --no-tags linux-review Niklas-Schnelle/asm-generic-io-h-Silence-Wnull-pointer-arithmetic-warning-on-PCI_IOBASE/20210421-192025
        git checkout 05bc9b9b640336015712d139ebc42830d12a82da
        # save the attached .config to linux build tree
        COMPILER_INSTALL_PATH=$HOME/0day COMPILER=gcc-9.3.0 make.cross W=1 ARCH=h8300 

If you fix the issue, kindly add following tag as appropriate
Reported-by: kernel test robot <[email-masked]>

All errors (new ones prefixed by >>):

   In file included from arch/h8300/include/asm/io.h:63,
                    from drivers/input/gameport/lightning.c:13:
   include/asm-generic/io.h: In function '_inb':
>> include/asm-generic/io.h:465:2: error: implicit declaration of function 'WARN_ONCE' [-Werror=implicit-function-declaration]
     465 |  WARN_ONCE(1, "No I/O port support\n");
         |  ^~~~~~~~~
   cc1: some warnings being treated as errors

vim +/WARN_ONCE +465 include/asm-generic/io.h

   446	
   447	/*
   448	 * {in,out}{b,w,l}() access little endian I/O. {in,out}{b,w,l}_p() can be
   449	 * implemented on hardware that needs an additional delay for I/O accesses to
   450	 * take effect.
   451	 */
   452	
   453	#if !defined(inb) && !defined(_inb)
   454	#define _inb _inb
   455	static inline u8 _inb(unsigned long addr)
   456	{
   457	#ifdef PCI_IOBASE
   458		u8 val;
   459	
   460		__io_pbr();
   461		val = __raw_readb(PCI_IOBASE + addr);
   462		__io_par(val);
   463		return val;
   464	#else
 > 465		WARN_ONCE(1, "No I/O port support\n");
   466		return ~0;
   467	#endif
   468	}
   469	#endif
   470	

---
0-DAY CI Kernel Test Service, Intel Corporation
https://lists.01.org/hyperkitty/list/[email-masked]